
#include <stdlib.h>
#include <math.h>

#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include "glut.h"
#endif

	GLfloat vertices[] = {
			-1.0,-1.0,-1.0, //0 (0,1,2)
			1.0,-1.0,-1.0,  //1 (3,4,5)
			1.0,1.0,-1.0,   //2 (6,7,8)
			-1.0,1.0,-1.0,  //3 (9,10,11)
			-1.0,-1.0,1.0,  //4 (12,13,14)
			1.0,-1.0,1.0,   //5 (15,16,17)
			1.0,1.0,1.0,    //6 (18,19,20)
			-1.0,1.0,1.0};  //7 (21,22,23)

	GLfloat colors[] = {
		0.0,0.0,0.0, //0 (0,1,2)
		1.0,0.0,0.0, //1 (3,4,5)
		1.0,1.0,0.0, //2 (6,7,8)
		0.0,1.0,0.0, //3 (9,10,11)
		0.0,0.0,1.0, //4 (12,13,14)
		1.0,0.0,1.0, //5 (15,16,17)
		1.0,1.0,1.0, //6 (18,19,20)
		0.0,1.0,1.0}; //7 (21,22,23)

    GLubyte cubeIndices[]={0,3,2,1,2,3,7,6,0,4,7,3,1,2,6,5,4,5,6,7,0,1,5,4};



static GLfloat theta[] = {0.0,0.0,0.0};
static GLint axis = 2;


// the camera info  
float eye[3];
float lookat[3];
int angle;

void drawBackFace(){
	glBegin(GL_QUADS);
		glColor3f(colors[0], colors[1], colors[2]);          // 0
		glVertex3f(vertices[0], vertices[1], vertices[2]);   // 0
		glColor3f(colors[9], colors[10], colors[11]);        // 3
		glVertex3f(vertices[9], vertices[10], vertices[11]); // 3	
		glColor3f(colors[6], colors[7], colors[8]);          // 2
		glVertex3f(vertices[6], vertices[7], vertices[8]);   // 2
		glColor3f(colors[3], colors[4], colors[5]);          // 1
		glVertex3f(vertices[3], vertices[4], vertices[5]);   // 1
	glEnd();
}

void drawFrontFace(){
	glBegin(GL_QUADS);
		glColor3f(colors[12], colors[13], colors[14]);       // 4
		glVertex3f(vertices[12], vertices[13], vertices[14]);// 4
		glColor3f(colors[15], colors[16], colors[17]);       // 5
		glVertex3f(vertices[15], vertices[16], vertices[17]);// 5
		glColor3f(colors[18], colors[19], colors[20]);       // 6
		glVertex3f(vertices[18], vertices[19], vertices[20]);// 6
		glColor3f(colors[21], colors[22], colors[23]);       // 7
		glVertex3f(vertices[21], vertices[22], vertices[23]);// 7	

	glEnd();
}
void drawRightFace(){
	glBegin(GL_QUADS);
		glColor3f(colors[15], colors[16], colors[17]);       // 5
		glVertex3f(vertices[15], vertices[16], vertices[17]);// 5
		glColor3f(colors[3], colors[4], colors[5]);          // 1
		glVertex3f(vertices[3], vertices[4], vertices[5]);   // 1	
		glColor3f(colors[6], colors[7], colors[8]);          // 2
		glVertex3f(vertices[6], vertices[7], vertices[8]);   // 2
		glColor3f(colors[18], colors[19], colors[20]);          // 6
		glVertex3f(vertices[18], vertices[19], vertices[20]);   // 6
	glEnd();
}
void drawLeftFace(){
	glBegin(GL_QUADS);
		glColor3f(colors[0], colors[1], colors[2]);          // 0
		glVertex3f(vertices[0], vertices[1], vertices[2]);   // 0
		glColor3f(colors[12], colors[13], colors[14]);       // 4
		glVertex3f(vertices[12], vertices[13], vertices[14]);// 4	
		glColor3f(colors[21], colors[22], colors[23]);       // 7
		glVertex3f(vertices[21], vertices[22], vertices[23]);// 7
		glColor3f(colors[9], colors[10], colors[11]);        // 3
		glVertex3f(vertices[9], vertices[10], vertices[11]); // 3
	glEnd();
}
void drawTopFace(){
	glBegin(GL_QUADS);
		glColor3f(colors[21], colors[22], colors[23]);       // 7
		glVertex3f(vertices[21], vertices[22], vertices[23]);// 7
		glColor3f(colors[18], colors[19], colors[20]);       // 6
		glVertex3f(vertices[18], vertices[19], vertices[20]);// 6	
		glColor3f(colors[6], colors[7], colors[8]);          // 2
		glVertex3f(vertices[6], vertices[7], vertices[8]);   // 2
		glColor3f(colors[9], colors[10], colors[11]);        // 3
		glVertex3f(vertices[9], vertices[10], vertices[11]); // 3
	glEnd();
}
void drawBottomFace(){
	glBegin(GL_QUADS);
		glColor3f(colors[0], colors[1], colors[2]);          // 0
		glVertex3f(vertices[0], vertices[1], vertices[2]);   // 0
		glColor3f(colors[3], colors[4], colors[5]);          // 1
		glVertex3f(vertices[3], vertices[4], vertices[5]);   // 1	
		glColor3f(colors[15], colors[16], colors[17]);       // 5
		glVertex3f(vertices[15], vertices[16], vertices[17]);// 5
		glColor3f(colors[12], colors[13], colors[14]);       // 4
		glVertex3f(vertices[12], vertices[13], vertices[14]);// 4
	glEnd();
}


void display(void)
{

/* display callback, clear frame buffer and z buffer,
   rotate cube and draw, swap buffers */

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);


	glRotatef(angle, -1.0, 1.0, -1.0);	

	drawFrontFace();
	drawBackFace();
	drawRightFace();
	drawLeftFace();
	drawTopFace();
	drawBottomFace();
//   glColorPointer(3,GL_FLOAT, 0, colors); 
//   glDrawElements(GL_QUADS, 24, GL_UNSIGNED_BYTE, cubeIndices);


	glutSwapBuffers(); 
}



void myReshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (w <= h)
        glOrtho(-4.0, 4.0, -3.0 * (GLfloat) h / (GLfloat) w,
            5.0 * (GLfloat) h / (GLfloat) w, -10.0, 10.0);
    else
        glOrtho(-4.0 * (GLfloat) w / (GLfloat) h,
            4.0 * (GLfloat) w / (GLfloat) h, -3.0, 5.0, -10.0, 10.0);

	// make color cube's white vertex face the viewer
    glMatrixMode(GL_MODELVIEW);
	glRotatef(45, 1.0, 0.0, 0.0);
	glRotatef(-45, 0.0, 1.0, 0.0);
}



void myGlutIdle(void)
{

	// just keep redrawing the scene over and over
	glutPostRedisplay();
}

void keyboard(unsigned char key, int x, int y)
{
	switch(key)
	{
	case '<':
		angle--;
		break;
	case '>':
		angle++;
		break;
    }
	if (angle < 0 )
		angle = 0;

    glutPostRedisplay();
}



	
void
main(int argc, char **argv)
{


/* need both double buffering and z buffer */

    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH); // note that depth buffering is on
    glutInitWindowSize(500, 500);
    glutCreateWindow("colorcube");
    glutReshapeFunc(myReshape);
    glutDisplayFunc(display);
    glutKeyboardFunc(keyboard);
    glutIdleFunc(myGlutIdle);
   

    glEnable(GL_DEPTH_TEST); /* Enable hidden--surface--removal */
 	glEnableClientState(GL_COLOR_ARRAY); 
	glEnableClientState(GL_VERTEX_ARRAY);
	glVertexPointer(3, GL_FLOAT, 0, vertices);
    glColorPointer(3,GL_FLOAT, 0, colors); 
	glClearColor(1.0,1.0,1.0,1.0);
	glColor3f(1.0,1.0,1.0);

		// initialize the camera
	eye[0] = 1;
	eye[1] = 1;
	eye[2] = 1;
	lookat[0] = 0;
	lookat[1] = 0;
	lookat[2] = 0;

    glutMainLoop();
}
